function data_urlencode()

	local str = sr.pv.get("$var(push_caller_numb)");
	local number = url_encode(str);
	sr.pv.sets("$var(push_caller_numb)", number)

	local str = sr.pv.get("$var(push_calling_numb)");
	local number = url_encode(str);
	sr.pv.sets("$var(push_calling_numb)", number)

	local str = sr.pv.get("$var(push_caller_name)");
	local name = url_encode(str);
	sr.pv.sets("$var(push_caller_name)", name)

	local str = sr.pv.get("$var(push_calling_name)");
	local name = url_encode(str);
	sr.pv.sets("$var(push_calling_name)", name)

	local str = sr.pv.get("$var(push_message)");
	local name = url_encode(str);
	sr.pv.sets("$var(push_message)", name)

end

function url_encode(str)
	if (str) then
		str = string.gsub (str, "\n", "\r\n")
		str = string.gsub (str, "([^%w %-%_%.%~])",
		function (c) return string.format ("%%%02X", string.byte(c)) end)
		str = string.gsub (str, " ", "+")
	end
	return str
end

function remove_x_wildix_id()

	local mb_in  = sr.pv.get("$mb")
	local mb_out = nil
	local mb_tmp = nil
	local mb_xml = nil
	local len    = nil
	local content_length = nil

	
	-- remove X-Wildix-id param from body of NOTIFY
	mb_tmp = string.gsub(mb_in, "<param%spname=\"X%-Wildix%-id\"%spval.-/>\n", "")

	-- get XML part of NOTIFY
	mb_xml = string.gsub(mb_tmp, "NOTIFY sip:.*<?xml%sversion=", "<?xml version=")

	-- calculate length of XML part in NOTIFY
	len = string.len( mb_xml )

	-- reconstruct new Content-Length
	content_length = "Content-Length: " .. len .. "\r\n"

	-- replace Content-Length
	mb_out = string.gsub(mb_tmp, "Content%-Length:.-\n", content_length)

	-- return the value of reconstructed NOTIFY back to kamailio
	sr.pv.sets("$var(mb_out)", mb_out)

end


function parse_ice_candidates()

	function startswith(self, str)
		return self:sub(1, #str) == str
	end

	local lines = {}
	local sdp = sr.pv.get("$rb")

	local media_type
	local candidates = {audio = {srflx = 0, tcprelay = 0, udprelay = 0},
						video = {srflx = 0, tcprelay = 0, udprelay = 0}}
	local candidates_lines = {}

	if type(sdp) == "string" then
		for line in string.gmatch(sdp, "(.-)\r?\n") do

			if startswith(line, "m=audio") then
				media_type = "audio"
				table.insert(candidates_lines, line)
			elseif startswith(line, "m=video") then
				media_type = "video"
				table.insert(candidates_lines, line)
			end

			local candidate_type
			if startswith(line, "a=candidate") then
				table.insert(candidates_lines, line)
				if line:find("srflx") then
					candidate_type = "srflx"
				elseif line:find("typ relay") then
					if line:find("127.0.0.1") then
						candidate_type = "tcprelay"
					else
						candidate_type = "udprelay"
					end
				end
			end

			if media_type and candidate_type then
				candidates[media_type][candidate_type] = candidates[media_type][candidate_type] + 1
			end
		end
	end

	local msg = string.format("%s/%s/%s/%s/%s/%s", candidates["audio"]["srflx"],
													candidates["audio"]["tcprelay"],
													candidates["audio"]["udprelay"],
													candidates["video"]["srflx"],
													candidates["video"]["tcprelay"],
													candidates["video"]["udprelay"])
	sr.pv.sets("$var(candidates)", msg)
	sr.pv.sets("$var(candidates_debug)", table.concat(candidates_lines, "\n"))
end
